
#include "fxlib.h"
#include "stdlib.h"
#include <string.h>

#include "game.h"
#include "borders.h"
#include "MonochromeLib.h"
#include "Ecode.h"
#include "syscall.h"
#include "struct.h"

int game()
{
	Box perso;
	Lvl level;
	Borders *list = NULL;
    float dy =0.0, ay = 0.0;
    unsigned int time, time2;
    int done = 0, numLevel = 6, score = 0;
    char titre[20] = " 1/10", msg[32] = "", str[16] = "";
    int keyExe;


	while(!done)
	{
		perso.x = 0;
		perso.y = 30;
		perso.w = perso.h = 5;
		dy = ay = 0.0;
		list = load_level(list, numLevel, &level, msg);

		keyExe = 1;
		ML_clear_vram();
		ML_rectangle(perso.x, perso.y, perso.x+perso.w, perso.y+perso.h, 2, BLACK, BLACK);
		display_list(list);

		titre[1] = (numLevel%10) +'0';
		if(numLevel > 9)
			titre[0] = (numLevel/10) + '0';
		PrintMini( 54, 1, titre, MINI_REV);
		intToStr(str, score);
		PrintMini(10, 1, str, MINI_REV);

		//PrintMini(52, 26, " Go ! ", MINI_REV);
		PrintMini((128-(strlen(msg)*4))/2, 29, msg, MINI_REV);
		ML_display_vram();
		while(!done)
		{
			if( KeyUp(K_EXE))
				keyExe = 0;
			if(KeyDown(K_EXE) && keyExe == 0)
				break;
			if(KeyDown(K_EXIT))
				done = 1;
		}

		time = time2 = RTC_GetTicks();
		while(!done)
		{
			ML_clear_vram();
			if(KeyDown(K_EXIT))
				done = 1;
			if(time + level.time <= RTC_GetTicks() )
			{
				if(KeyDown(K_EXE))
					ay = -level.ay;
				else
					ay = level.ay;

				if(dy > -1.0 && dy < 1.0)
					ay *= 5;

				dy += ay;
				perso.y += (int)dy;

				time = RTC_GetTicks();
			}
			if(time2 + level.time2 <= RTC_GetTicks())
			{
				if(perso.x < 123)
					perso.x ++;
				else
				{
					numLevel++;
					break;
				}

				time2 = RTC_GetTicks();
			}
			if(coll_list(list, &perso))
			{
				score ++;
				break;
			}

			ML_rectangle(perso.x, perso.y, perso.x+perso.w, perso.y+perso.h, 2, BLACK, BLACK);
			display_list(list);
			PrintMini( 54, 1, titre, MINI_REV);
			PrintMini(10, 1, str, MINI_REV);


			ML_display_vram();
		}
		suppr_all(list);
		list = NULL;
		if(numLevel == 13)
		{
			good_game(score);
			return 0;
		}
	}
	while(KeyDown(K_EXIT));

	return 0;
}

void good_game(int score)
{
	int keyExe = 1;
	char str[16]="";

	ML_clear_vram();
	ML_rectangle(0, 0, 127, 63, 1, BLACK, BLACK);
	locate(5, 3);
	PrintRev("Good Game !!!");
	locate(5, 5);
	PrintRev("Score : ");
	intToStr(str, score);
	locate(13, 5);
	PrintRev(str);
	ML_display_vram();
	while(1)
	{
		if(KeyUp(K_EXE) && keyExe == 1)
			keyExe = 0;
		if(KeyDown(K_EXE) && keyExe == 0)
			break;
		Sleep(20);
	}
	while(KeyDown(K_EXE));
}
void display_list(Borders *list)
{
	Borders *tmp;
	tmp = list;

	while(tmp)
	{
		ML_rectangle(tmp->x1, tmp->y1, tmp->x2, tmp->y2, 1, BLACK, BLACK);

		tmp = tmp->nxt;
	}
}

int coll_list(Borders *list, Box *perso)
{
	Borders *tmp;
	tmp = list;


	while(tmp)
	{
		if( ! ((tmp->x1 >= perso->x + perso->w)
		|| (tmp->x2+1 <= perso->x)
		|| (tmp->y1 >= perso->y + perso->h)
		|| (tmp->y2+1 <= perso->y)))
			  return 1;
		tmp = tmp->nxt;
	}
	return 0;
}
Borders *load_level(Borders *list, int numLevel, Lvl *level, char *msg)
{

	switch(numLevel)
	{
		default :
		case 1:
			list = load_level_1(list, level, msg);
			break;
		case 2:
			list = load_level_2(list, level, msg);
			break;
		case 3:
			list = load_level_3(list, level, msg);
			break;
		case 4:
			list = load_level_4(list, level, msg);
			break;
		case 5:
			list = load_level_5(list, level, msg);
			break;
		case 6:
			list = load_level_6(list, level, msg);
			break;
		case 7:
			list = load_level_7(list, level, msg);
			break;
		case 8:
			list = load_level_8(list, level, msg);
			break;
		case 9:
			list = load_level_9(list, level, msg);
			break;
		case 10:
			list = load_level_10(list, level, msg);
			break;
		case 11:
			list = load_level_11(list, level, msg);
			break;
		case 12:
			list = load_level_12(list, level, msg);
			break;

	}
	return list;
}

Borders *load_level_1(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.05;
	level->time = 6;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 55, 127, 63);
	memcpy(msg, " Press EXE for to start ", 25);
	return list;
}
Borders *load_level_2(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	memcpy(msg, " Welcome to Earth's gravity ", 29);
	return list;
}
Borders *load_level_3(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 15);
	list = add_border(list, 0, 48, 127, 63);
	memcpy(msg, " A bit tighter ", 16);
	return list;
}
Borders *load_level_4(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	list = add_border(list, 60, 8, 68, 24);
	list = add_border(list, 60, 40, 68, 55);
	memcpy(msg, " Can you fit here ? ", 21);
	return list;
}
Borders *load_level_5(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.15;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 15);
	list = add_border(list, 0, 48, 127, 63);
	memcpy(msg, " This place seems Jupiter ", 28);
	return list;
}
Borders *load_level_6(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 8);
	list = add_border(list, 0, 48, 127, 63);
	list = add_border(list, 60, 8, 68, 12);
	list = add_border(list, 60, 28, 68, 55);
	memcpy(msg, " Can you fit here ? ", 21);
	return list;
}
Borders *load_level_7(Borders *list, Lvl *level, char *msg)
{
	level->ay = -0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	memcpy(msg, " Upside down ", 14);
	return list;
}
Borders *load_level_8(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	list = add_border(list, 60, 8, 68, 34);
	list = add_border(list, 60, 50, 68, 55);
	memcpy(msg, " Can you fit here ? ", 21);
	return list;
}
Borders *load_level_9(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	list = add_border(list, 30, 8, 31, 32);
	list = add_border(list, 60, 30, 61, 55);
	list = add_border(list, 90, 8, 91, 32);
	memcpy(msg, " ZigZag Easy ", 14);
	return list;
}
Borders *load_level_10(Borders *list, Lvl *level, char *msg)
{
	level->ay = -0.12;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	memcpy(msg, " Upside down ", 14);
	return list;
}
Borders *load_level_11(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 22);
	list = add_border(list, 0, 42, 127, 63);
	memcpy(msg, " A bit tighter ", 16);
	return list;
}
Borders *load_level_12(Borders *list, Lvl *level, char *msg)
{
	level->ay = 0.07;
	level->time = 4;
	level->time2 = 7;
	list = add_border(list, 0, 0, 127, 7);
	list = add_border(list, 0, 56, 127, 63);
	list = add_border(list, 34, 8, 35, 32);
	list = add_border(list, 60, 26, 61, 55);
	list = add_border(list, 86, 8, 87, 32);
	memcpy(msg, " ZigZag Medium ", 16);
	return list;
}



